/*
 * Copyright (c) 2012-2014 Kaarle Ritvanen
 * See LICENSE file for license details
 */

define(
    ["aconf/statusbar", "aconf/widget/abstract/inline", "jquery", "underscore"],
    function(statusBar, Base, $, _) {
	return Base.extend({
	    init: function(
		data, name, meta, level, editable, removable
	    ) {
		return Base.init.call(
		    this,
		    data,
		    name,
		    meta,
		    Math.min(6, level + 1),
		    editable,
		    removable
		);
	    },

	    showStatus: false,
	    
	    _requestData: function(value, meta) { return this.refreshData(); },

	    showHeading: true,

	    render: function(data, meta) {
		if (this.showHeading)
		    this.el.html(
			$("<h" + this.level + ">").text(meta["ui-name"])
		    );
	    },

	    wrap: function() { return this.el; },

	    validate: function(data) {
		Base.validate.call(this, data);

		if (this.data.match(this.meta.condition)) {
		    var valid = data.validate();
		    this.setStatus(data.status());
		    statusBar.validationReady(valid);
		}
	    }
	});
    }
);
